local i4, i2, i1, u4, u2, u1, pchar = mem.i4, mem.i2, mem.i1, mem.u4, mem.u2, mem.u1, mem.pchar
local mmver = offsets.MMVersion

local function mmv(...)
	local ret = select(mmver - 5, ...)
	assert(ret ~= nil)
	return ret
end

local _KNOWNGLOBALS = Game, Party, Map

function structs.f.GameStructure(define)
	if mmver == 7 then
		define[0].struct(structs.GameRaces)  'Races'
	end
	define
	[0].struct(structs.GameClasses)  'Classes'
	[0].struct(structs.GameClassKinds)  'ClassKinds'
	[0].struct(structs.GameParty)  'Party'
	[0].struct(structs.GameMap)  'Map'
	[mmv(0x6A6110, 0, 0)].struct(structs.GameMouse)  'Mouse'
	[0].struct(structs.Weather)  'Weather'
	[offsets.MainWindow].u4  'WindowHandle'
	[offsets.Windowed].u4  'Windowed'
	[offsets.CurrentPlayer].CustomType('CurrentPlayer', 4, function(o, obj, name, val)
		if val == nil then
			return u4[o] - 1
		else
			u4[o] = val + 1
		end
	end)
	[mmv(0x4C2750, 0x4EDD80, 0x4FDF88)].array(13).i2  'SkillRecoveryTimes'
	[mmv(0x4BCDD8, 0x4E28D8, 0x4F37D8)].i4  'CurrentScreen'
	[mmv(0x4D4714, 0x506DC8, 0x5185A8)].i4  'CurrentCharScreen'
	--[mmv(0x4D48F8, nil, nil)].array{20, lenA = i4, lenP = mmv(0x4D46BC, nil, nil)}.struct(structs.Dlg)  'DialogsStack'
	[mmv(0x4D5088, 0x5079F8, 0x5192EC)].array(7).EditPChar  'StatsNames'
	[mmv(0x56F27C, 0x5C85F8, 0x5E4990)].array(7).EditPChar  'StatsDescriptions'
	if mmver == 6 then
		define
		[0x970C7C].array(31).EditPChar  'SkillNames'
		[0x56F394].array(31).EditPChar  'SkillDescriptions'
		[0x56B6C0].array(18).EditPChar  'ClassDescriptions'
		[0x970BEC].array(18).EditPChar  'ClassNames'
	else
		define
		[mmv(nil, 0xAE3150, 0xBB3060)].array(37).EditPChar  'SkillNames'
		[mmv(nil, 0x5C88F0, 0x5E4CB0)].array(37).EditPChar  'SkillDescriptions'
		[mmv(nil, 0xAE3070, 0xBB2FD0)].array(36).EditPChar  'ClassNames'
		[mmv(nil, 0x5C8560, 0x5E48F0)].array(36).EditPChar  'ClassDescriptions'
	end
	define
	[mmv(0x4D5F4C, 0x50CA54, 0x51E334)].array{40, lenA = i4, lenP = mmv(0x4D5F48, 0x50CA50, 0x51E330)}.struct(structs.ActionItem)  'Actions'
	[mmv(0x52D29C, 0x576EAC, 0x587ADC)].b4  'NeedRedraw'
	[mmv(0x55BC04, 0x5C32A8, 0x5DB758)].string(200)  'StatusMessage'
	.string(200)  'MouseOverStatusMessage'
	.i4  'StatusDisappearTime'
	-- (MM6)
	-- 54F060 Timers
	-- 552F50 TimersCount
	-- 5F883C ; char SaveSlotsFiles[40][280]
	-- 5FB9B4 SaveSlotsCount
	-- 6296EC dist_mist

	[mmv(0x560C14, 0x5D2864, 0x5EFBCC)].array{mmv(581, 800, 803), lenA = i4, lenP = mmv(0x560C10, 0x5D2860, 0x5EFBC8)}.struct(structs.ItemsTxtItem)  'ItemsTxt'
	if mmver == 6 then
		define[0x56C188].array{174, lenA = i4, lenP = 0x56C188 + structs.MonstersTxtItem["?size"]*174}.struct(structs.MonstersTxtItem)  'MonstersTxt'
	elseif mmver == 7 then
		define[0x5CCCC0].array{265, lenA = i4, lenP = 0x5CCCC0 + 23444}.struct(structs.MonstersTxtItem)  'MonstersTxt'
		[0x5D27D8].array{31, lenA = i4, lenP = 0x5CCCC0 + 23448}.EditPChar  'PlaceMonTxt'
	else
		define[0x5E9530].array{268, lenA = i4, lenP = 0x5E9530 + 6563*4}.struct(structs.MonstersTxtItem)  'MonstersTxt'
		[0x5EF9B0].array{131, lenA = i4, lenP = 0x5E9530 + 6564*4}.EditPChar  'PlaceMonTxt'
	end
	if mmver == 6 then
		define[mmv(0x55F628, nil, nil)].array{100, lenA = i4, lenP = mmv(0x55F628, nil, nil) + 5600}.struct(structs.MapStatsItem)  'MapStats'
	else
		define[mmv(nil, 0x5CAA38, 0x5E6E00)].array{77, lenA = i4, lenP = mmv(nil, 0x5CAA38, 0x5E6E00) + 0x44*77}.struct(structs.MapStatsItem)  'MapStats'
	end
	define[mmv(0x4C3B74, 0x4EFEC8, 0x5004E8)].array(mmv(68, 78, 78)).i2  'MapDoorSound'
	
	define.union 'MoveToMap'
		[mmv(0x551D20, 0x5B6428, 0x5CCCB8)].array(3).i4  'Pos'
		[mmv(0x551D20, 0x5B6428, 0x5CCCB8)].i4  'X'
		.i4  'Y'
		.i4  'Z'
		.i4  'Direction'
		.i4  'LookAngle'
		.i4  'SpeedZ'
		.b4  'Defined'
	.union()
	[mmv(0x55BDB4, 0x5C346C, 0x5DB91C)].i4  'Lucida_fnt'
	[mmv(0x55BDB8, 0x5C3488, 0x5DB938)].i4  'Smallnum_fnt'
	[mmv(0x55BDC4, 0x5C3468, 0x5DB918)].i4  'Arrus_fnt'
	[mmv(0x55BDC8, 0x5C347C, 0x5DB92C)].i4  'Create_fnt'
	[mmv(0x55BDCC, 0x5C3484, 0x5DB934)].i4  'Comic_fnt'
	[mmv(0x55BDBC, 0x5C3474, 0x5DB924)].i4  'Book_fnt'
	[mmv(0x55BDD4, 0x5C3470, 0x5DB920)].i4  'Book2_fnt'
	if mmver < 8 then
		define[mmv(0x55BDDC, 0x5C3480, nil)].i4  'Cchar_fnt'
	end
	define
	[mmv(0x55BDD0, 0x5C3460, 0x5DB910)].i4  'Autonote_fnt'
	[mmv(0x55BDC0, 0x5C3464, 0x5DB914)].i4  'Spell_fnt'  -- Autonote_fnt2
	[mmv(0x55CDE0, 0x5C5C30, 0x5DF0E0)].string(500)  'TextBuffer'
	[mmv(0x55D5B0, 0x5C6400, 0x5E1020)].string(500)  'TextBuffer2'
	[mmv(0x5F6E0C, 0x69AC8C, 0x6C8BC4)].array(mmv(12, 30, 30)).i4  'KeyCodes'
	[mmv(0x5F6E3C, 0x69AD04, 0x6C8C3C)].array(mmv(12, 30, 30)).i4  'KeyTypes'
	[mmv(0x908D08, 0xACCE64, 0xB20EBC)].i8  'Time'
	 .Info "256*(minutes since 00 AM 1 January 1165/1168/1172)"
	[mmv(0x908D10, 0xACD544, 0xB215AC)].i4  'Year'
	 .Info "Actual value, like 1172"
	[mmv(0x908D14, 0xACD548, 0xB215B0)].i4  'Month'  -- (0 - 11)
	 .Info "(0 - 11)"
	[mmv(0x908D18, 0xACD54C, 0xB215B4)].i4  'WeekOfMonth'  -- (0 - 3)
	 .Info "(0 - 3)"
	[mmv(0x908D1C, 0xACD550, 0xB215B8)].i4  'DayOfMonth'  -- (0 - 27), add 1 to it
	 .Info "(0 - 27), add 1 to it"
	[mmv(0x908D20, 0xACD554, 0xB215BC)].i4  'Hour'  -- (0 - 23)
	 .Info "(0 - 23)"
	[mmv(0x908D24, 0xACD558, 0xB215C0)].i4  'Minute'  -- (0 - 59)
	 .Info "(0 - 59)"
	[mmv(0x908D28, 0xACD55C, 0xB215C4)].i4  'Second'  -- (0 - 59)
	 .Info "(0 - 59)"
	[mmv(0x45031C, 0x460465, 0x45DEBB)].CustomType('BaseYear', 0, function(o, obj, _, val)
		if val == nil then
			return i4[o]
		else
			local t = mmv(
				{0x45031C, 0x47D9DC, 0x47DB1C, 0x47DC5C, 0x47DD9C, 0x47DEDC, 0x47E01C, 0x47E1A1, 0x47E2EB, 0x47E6EB, 0x47E8B4, 0x47FC27, 0x481D06, 0x481F3D, 0x4825EB, 0x48277B, 0x482914, 0x482998, 0x483FBC, 0x484E96, 0x4881C0, 0x4962BD}, 
				{0x460465, 0x48E71F, 0x49401D, 0x494115, 0x4B1C3C},
				{0x45DEBB, 0x48DB8A, 0x492253, 0x49234B, 0x4B0428}
			)
			mem.IgnoreProtection(true)
			for _, p in ipairs(t) do
				i4[p] = val
			end
			mem.IgnoreProtection(false)
		end
	end)
	[mmv(0x90E838, 0xAD45B0, 0xB7CA88)].bit ('NeedRender', 2)
	 .Info "Same as Party.NeedRender"
	[mmv(0x908E30, 0xACD6B4, 0xB21728)].i4  'TurnBased'
	[mmv(0x4C7DF4, 0x4F86DC, 0x509C9C)].i4  'TurnBasedPhase'  -- 1 = monsters move, 2 = combat, 3 = party walking
	[mmv(0x9CF598, 0xF78F58, 0xFEB360)].i4  'PlaySoundStruct'
	[mmv(0x9CF5A0, 0xF791FC, 0xFEB604)].i4  'RedbookHandle'
	[mmv(0x9CF5A4, 0xF79200, 0xFEB608)].i4  'MSSHandle'
	if mmver == 6 then
		define[mmv(0x9CF5C0, nil, nil)].i4  'MasterVolume'
	end
	if mmver > 6 then
		define[mmv(nil, 0xF8BA08, 0xFFDE00)].i4  'BinkVideo'
	end
	define
	[mmv(0x9DE364, 0xF8B9B0, 0xFFDDA8)].i4  'SmackVideo'
	[mmv(0x4BF8A0, 0x4E8348, 0x4F7F4C)].array(20).u1  'EquipStat2ItemSlot'  -- (24) ?
	[offsets.TimeStruct1 + 4].b4  'Paused'  -- checked by event timers
	 .Info "checked by event timers"
	[offsets.TimeStruct2 + 4].b4  'Paused2'  -- checked by water damage
	 .Info "checked by water damage"
	-- MM6: 4C4468 - something related to shop items generation
	[mmv(0x90EC2C, 0xAD45B4, 0xB7CA8C)].array(mmv(1, 0, 0), mmv(47, 52, 52)).array(12).struct(structs.Item)  'ShopItems'
	[mmv(0x9129DC, 0xAD9F24, 0xB823FC)].array(mmv(1, 0, 0), mmv(41, 52, 52)).array(12).struct(structs.Item)  'ShopSpecialItems'
	if mmver == 6 then
		define[0x91663C].array(119, 140).array(12).struct(structs.Item)  'GuildItems'
	elseif mmver == 7 then
		define[0xADF894].array(139, 170).array(12).struct(structs.Item)  'GuildItems'
	else
		define[0xB87D6C].array(139, 172).array(12).array(12).struct(structs.Item)  'GuildItems'
	end
	if mmver < 8 then
		define[mmv(0x4CA718, 0x505828)].array(480).i4  'ScanlineOffset'
	end
	define
	[mmv(0x90E894, 0xACCEC4, 0xB20F1C)].array(mmv(1, 0, 0), mmv(47, 52, 52)).i8  'ShopNextRefill'
	[mmv(0x9B1090, 0xE31A9C, 0xF019B4)].parray(480).array(640).struct(structs.ObjectRef)  'ObjectByPixel'
	[mmv(0x918938, 0xAE2F74, 0xBB2E04)].i4  'ArmageddonTimeLeft'  -- maximum is 417
	 .Info "maximum is 417"
	[mmv(0x91893C, 0xAE2F78, 0xBB2E08)].i4  'ArmageddonSkill'  -- damage is 50 + skill
	 .Info "damage is 50 + skill"
	[mmv(0x52D530, 0x5912B8, 0x5A5728)].array(mmv(558, 526, 526)).struct(structs.Events2DItem)  'Houses'  -- 2DEvents
	 .Info "2DEvents"
	-- MM6:
	-- 4BE3B8 Event2DMapMoveX
	-- 4BE3D0 Event2DMapMoveY
	-- 4BE3E8 Event2DMapMoveZ
	-- 4BE400 Event2DMapMoveDirection
	[mmv(0x6A7680, 0x7214E8, 0x75E450)].array{1, mmv(517, 789, 1000), ItemSize = 8}.EditPChar  'NPCTopic'
	[mmv(0x6A7684, 0x7214EC, 0x75E454)].array{1, mmv(517, 789, 1000), ItemSize = 8}.EditPChar  'NPCText'
	if mmver > 6 then
		define
		[mmv(nil, 0x73B8D4, 0x7798B8)].array{0, 205}.array{0, 1}.EditPChar  'NPCGreet'
		[mmv(nil, 0x73BFAA, 0x779F8E)].array(0, 50).i4  'NPCGroup'
		[mmv(nil, 0x739CF4, 0x778F50)].array(0, 50).EditPChar  'NPCNews'
		[mmv(nil, 0x5C89E0, 0x5E4DA8)].array(1, 29).struct(structs.HistoryTxtItem)  'HistoryTxt'
	else
		define
		[0x6B8C60].array{0, 279}.struct(structs.NPCNewsItem)  'NPCNews'
		[0x6BA568].array(96).i2  'NPCNewsCountByMap'
	end
	if mmver < 8 then
		define[mmv(0x6AEF28, 0x72D50C)].array{0, mmv(399, 499), lenA = i4, lenP = mmv(0x6BA534, 0x73C014)}.struct(structs.NPC)  'NPC'
	else
		define[0x76BD2C].array{0, 549}.struct(structs.NPC)  'NPC'
	end
	define
	[mmv(0x4BDD6E, 0x4E3C46, 0x4F486E)].array(0, mmv(99, 99, 132)).struct(structs.SpellInfo)  'Spells'
	[mmv(0x56ABD0, 0x5CBEB0, 0x5E8278)].array(0, mmv(99, 99, 132)).struct(structs.SpellsTxtItem)  'SpellsTxt'
	[mmv(0x6A8808, 0x722D94, 0x760394)].array(1, 512).EditPChar  'QuestsTxt'
	if mmver == 6 then
		define[0x6A900C].array{1, 87}.EditPChar  'AwardsTxt'
	else
		define
		[mmv(nil, 0x723D08, 0x761650)].array{1, 104, ItemSize = 8}.EditPChar  'AwardsTxt'
		[mmv(nil, 0x723D0C, 0x761654)].array{1, 104, ItemSize = 4}.i4  'AwardsSort'
	end
	if mmver == 6 then
		define[0x6BA62C].array{1, 128}.EditPChar  'AutonoteTxt'
	elseif mmver == 7 then
		define
		[0x7235A0].array{1, 195, ItemSize = 8}.EditPChar  'AutonoteTxt'
		[0x7235A4].array{1, 195, ItemSize = 8}.i4  'AutonoteCategory'
		 .Info "0 = potion\n1 = stat\n2 = obelisk\n3 = seer\n4 = misc\n5 = teacher"
	else
		define
		[0x760BA0].array{1, 300, ItemSize = 8}.EditPChar  'AutonoteTxt'
		[0x760BA4].array{1, 300, ItemSize = 8}.i4  'AutonoteCategory'
		 .Info "0 = potion\n1 = stat\n2 = obelisk\n3 = seer\n4 = misc\n5 = teacher"
	end
	define
	[mmv(0x4D50A8, 0x507A18, 0x51930C)].b4  'CtrlPressed'
	[mmv(0x4C1F98, 0x4ECA60, 0x4FCA88)].array(6).struct(structs.TownPortalTownInfo)  'TownPortalInfo'
	[mmv(0x4BCAE4, 0x4E1D2C, 0x501BC8)].array(6).i2  'TownPortalX'
	[mmv(0x4BCAF0, 0x4E1D38, 0x501BD4)].array(6).i2  'TownPortalY'
	if mmver < 8 then
		define
		[mmv(0x4BCB08, 0x4E1D50)].array(6).i2  'TownPortalHeight'
		[mmv(0x4BCAFC, 0x4E1D44)].array(6).i2  'TownPortalWidth'
	end
	-- town portal picture: townport
	-- town portal icons: tpharmndy, tpelf, tpwarlock, tpisland, tpheaven, tphell
	define
	[mmv(0x4C3F20, 0x4F0830, 0x500DF8)].array(mmv(36, 35, 25)).struct(structs.TravelInfo)  'TransportLocations'
	[mmv(0x4C43A0, 0x4F0C90, 0x501118)].array(mmv(48, 54, 54), mmv(68, 73, 73)).array(1, mmv(3, 4, 4)).i1  'TransportIndex'
	if mmver > 6 then
		define[mmv(nil, 0x5C8B40, 0x5E4F08)].array(89).array(89).u1  'HostileTxt'  -- HostileTxt[mon1][mon2] is attitude of mon1 to mon2. mon2 = 0 is party.
		 .Info "HostileTxt[mon1][mon2] is attitude of mon1 to mon2. mon2 = 0 is party."
	end
	define
	[mmv(0x457F52, 0x46627F, 0x46462C)].CustomType('NewGameMap', 4, function(o, obj, name, val)
		if val == nil then
			return pchar[o]
		else
			assert(#val < 14)
			mem.IgnoreProtection(true)
			structs.EditablePChar(o, obj, name, val)
			u4[mmv(0x458844, 0x460A0D, 0x45E322)] = u4[o]
			mem.IgnoreProtection(false)
			mem.copy(mmv(0x4D6B14, 0x510604, 0x521EE4), val, #val + 1)
		end
	end)
	[mmv(0x53CB6C, 0x598570, 0x5AC9E0)].array{mmv(3000, 4400, 5000), lenA = i4, lenP = mmv(0x54D038, 0x5A53B0, 0x5BB440)}.struct(structs.EventLine)  'GlobalEvtLines'
	[mmv(0x552F58, 0x5B6458, 0x5CCCE8)].array{mmv(3000, 4400, 5000), lenA = i4, lenP = mmv(0x533EB4, 0x5B0F90, 0x5C7020)}.struct(structs.EventLine)  'MapEvtLines'
	[mmv(0x55DD88, 0x5C6C40, 0x5E2FD0)].struct(structs.SFT)  'SFTBin'
	[mmv(0x5E2188, 0x69AC54, 0x6C8B5C) + 4].parray{lenA = i4, lenP = mmv(0x5E2188, 0x69AC54, 0x6C8B5C)}.struct(structs.DecListItem)  'DecListBin'
	[mmv(0x970BD8, 0xA74F6C, 0xAB3014) + 4].parray{lenA = i4, lenP = mmv(0x970BD8, 0xA74F6C, 0xAB3014)}.struct(structs.PFTItem)  'PFTBin'
	[mmv(0x944C58, 0xA74F64, 0xAB300C) + 4].parray{lenA = i4, lenP = mmv(0x944C58, 0xA74F64, 0xAB300C)}.struct(structs.IFTItem)  'IFTBin'
	[mmv(0x55DDA0, 0x5C6C38, 0x5E2FC8) + 4].parray{lenA = i4, lenP = mmv(0x55DDA0, 0x5C6C38, 0x5E2FC8)}.struct(structs.TFTItem)  'TFTBin'
	[mmv(0x5B22F0, 0x5FEFC4, 0x61C52C) + 4].parray{lenA = i4, lenP = mmv(0x5B22F0, 0x5FEFC4, 0x61C52C)}.struct(structs.DChestItem)  'ChestBin'
	[mmv(0x5C6BE8, 0x5E4FC8, 0x602530) + 4].parray{lenA = i4, lenP = mmv(0x5C6BE8, 0x5E4FC8, 0x602530)}.struct(structs.OverlayItem)  'OverlayBin'
	[mmv(0x5F6DF0, 0x680630, 0x6AE538) + 4].parray{lenA = i4, lenP = mmv(0x5F6DF0, 0x680630, 0x6AE538)}.struct(structs.ObjListItem)  'ObjListBin'
	[mmv(0x5E2178, 0x5FEFCC, 0x61C534) + 4].parray{lenA = i4, lenP = mmv(0x5E2178, 0x5FEFCC, 0x61C534)}.struct(structs.MonListItem)  'MonListBin'
	[mmv(0x9CF700, 0xF79BDC, 0xFEBFE4) + 4].parray{lenA = i4, lenP = mmv(0x9CF700, 0xF79BDC, 0xFEBFE4)}.struct(structs.SoundsItem)  'SoundsBin'
	[mmv(0x610740, 0x6BDEC8, 0x6F2FCC) + 4].parray{lenA = i4, lenP = mmv(0x610740, 0x6BDEC8, 0x6F2FCC)}.struct(structs.TileItem)  'TileBin'
	if mmver == 8 then
		define
		[0x6F2FC4 + 4].parray{lenA = i4, lenP = 0x6F2FC4}.struct(structs.TileItem)  'Tile2Bin'
		[0x6F2FBC + 4].parray{lenA = i4, lenP = 0x6F2FBC}.struct(structs.TileItem)  'Tile3Bin'
		[0x6F2FD4].pstruct(structs.CurrentTileBin)  'CurrentTileBin'
	end
	
	-- stditems, spcitems

	define
	[mmv(0x6104F8, 0x6A08E0, 0x6CE838)].struct(structs.Lod)  'GamesLod'
	[mmv(0x4CB6D0, 0x6D0490, 0x70D3E8)].struct(structs.BitmapsLod)  'IconsLod'
	[mmv(0x610AB8, 0x6F0D00, 0x72DC60)].struct(structs.BitmapsLod)  'BitmapsLod'
	[mmv(0x61AA10, 0x6E2048, 0x71EFA8)].struct(structs.SpritesLod)  'SpritesLod'
	[mmv(0x610830, 0x6A06A0, 0x6CE5F8)].struct(structs.Lod)  'SaveGameLod'
	if mmver == 7 then
		define[0x6BE8D8].struct(structs.Lod)  'EventsLod'
	end
	if mmver > 6 then
		define[mmv(nil, 0xE31AF0, 0xF01A08)].u4  'RendererD3D'
	end

	if mmver == 6 then
		define.func{name = "ShowMovie", p = mmv(0x4A59A0, nil, nil), cc = 2, must = 1; "", 0, 1}
	elseif mmver == 7 then
		define.func{name = "SetInterfaceColor", p = mmv(nil, 0x422698, nil), cc = 2, must = 1; 1, 1}  -- 0 - good, 1 - neutral, 2 - evil
	end
	define
	.func{name = "CalcSpellDamage", p = mmv(0x47F0A0, 0x43B006, 0x438B05), cc = 0, must = 4}
	 .Info{Sig = "Spell, Skill, Mastery, MonsterHP"}
	.func{name = "GetSpellDamageType", p = mmv(0x481A60, 0x48E189, 0x48D618), cc = 0, must = 1}
	 .Info{Sig = "Spell"}
	.func{name = "GetStatisticEffect", p = mmv(0x482DC0, 0x48EA13, 0x48E18E), cc = 0, must = 1}
	 .Info{Sig = "Stat"}
	.func{name = "EscMessage", p = mmv(0x40F480, 0x4141D5, 0x41365A), cc = 2, must = 1; "", 0}
	 .Info{Sig = "Text, Unk = 0"}
	.func{name = "SummonMonster", p = mmv(0x4A35F0, 0x4BBEC4, 0x4BA076), cc = 2, must = 4}
	 .Info{Sig = "Id, X, Y, Z"}
	if mmver > 6 then
		define.func{name = "IsMonsterOfKind", p = mmv(nil, 0x438BCE, 0x436542), cc = 2, must = 2}
	end
	function define.f.LoadSound(soundId, unk, unk2)
		-- unk2 present only in MM8
		mem.call(mmv(0x48E2D0, 0x4A99F7, 0x4A7F22), 1, mmv(0x9CF700, 0xF79BDC, 0xFEBFE4), soundId, unk or 0, unk2 or 0)
	end
	define.Info{Sig = "SoundId, Unk = 0"}
	function define.f.PlaySound(soundId, object, loops, x, y, unk, volume, playbackRate)
		mem.call(mmv(0x48EB40, 0x4AA29B, 0x4A87DC), 1, mmv(0x9CF598, 0xF78F58, 0xFEB360), soundId, object or -1, loops or 0, x or -1, y or 0, unk or 0, volume or 0, playbackRate or 0)
	end
	define.Info{Sig = "SoundId, Object = -1, Loops = 0, X = -1, Y = 0, Unk = 0, Volume = 0, PlaybackRate = 0"}
	function define.f.LoadDecSprite(name)
		local id = (mmver > 6 and mem.call(mmv(nil, 0x4488D9, 0x445C59), 1, mmv(nil, 0x69AC54, 0x6C8B5C), name) or 0)
		if mmver == 6 then
			name = name:lower()
			for i, a in Game.DecListBin do
				if a.Name:lower() == name then
					id = i
					break
				end
			end
		end
		mem.call(mmv(0x44AC80, 0x4586CC, 0x455F4A), 1, mmv(0x5E2188, 0x69AC54, 0x6C8B5C), id)
		return id
	end
	define.Info{Sig = "name";  "Loads a sprite and returns its ID."}
	function define.f.UpdateDialogTopics()
		if Game.CurrentScreen == 13 then
			i4[mmv(0x9DDD8C, 0xF8B01C, 0xFFD408)] = -1
			mem.call(mmv(0x4998A0, 0x4B4187, 0x4B2C36), 1, i4[mmv(0x551F94, 0x591270, 0x5A56E0)] - 1)
		end
	end
	function define.f.ShowStatusText(text, t)
		mem.call(mmv(0x442BD0, 0x44C1A1, 0x4496C5), 2, tostring(text), t or 2)
		Game.NeedRedraw = true
	end
	define.Info{Sig = "Text, Seconds = 2"}
	function define.f.LoadPalette(PalNum)
		return mem.call(mmv(0x47CBC0, 0x48A3A2, 0x489C9F), 1, mmv(0x762D80, 0x80D018, 0x84AFE0), PalNum)
	end
end

if mmver == 6 then

	function structs.f.GameClasses(define)
		define
		[0x4C2640].array(18).u1  'HPFactor'
		[0x4C2654].array(18).u1  'SPFactor'
		[internal.SPStatKinds].array(18).u1  'SPStats'
		 .Info "0 - no SP, 1 - Intellect, 2 - Personality, 3 - both"
	end

	function structs.f.GameClassKinds(define)
		define
		[0x4C2630].array(6).u1  'HPBase'
		[0x4C2638].array(6).u1  'SPBase'
		[0x4C2668].array(6).array(7).u1  'StartingStats'
		[0x4C2694].array(6).array(31).u1  'StartingSkills'
		 .Info "0 - not available,  1 - given on start,  2 - can choose on start,  3 - can learn"
	end

elseif mmver == 7 then

	function structs.f.GameClasses(define)
		define
		[0x4ED610].array(36).u1  'HPFactor'
		[0x4ED634].array(36).u1  'SPFactor'
		[0x4ED818].array(36).array(37).u1  'Skills'
		 .Info "0 - not available,  1 - Basic,  2 - Expert,  3 - Master, 4 - GM"
		[internal.SPStatKinds].array(36).u1  'SPStats'  -- 0 - no SP, 1 - Intellect, 2 - Personality, 3 - both
	end

	function structs.f.GameClassKinds(define)
		define
		[0x4ED5F8].array(9).u1  'HPBase'
		[0x4ED604].array(9).u1  'SPBase'
		[0x4ED6C8].array(9).array(37).u1  'StartingSkills'
		 .Info "0 - can't choose, 1 - can choose on start, 2 - given on start"
	end

	function structs.f.GameRaces(define)
		-- human, elf, goblin, dwarf
		define
		[0x4ED658].array(4).array(7).struct(structs.StartStat)  'StartingStats'
	end

elseif mmver == 8 then

	function structs.f.CurrentTileBin(define)
		define
		[4].parray{lenA = i4, lenP = 0}.struct(structs.TileItem)  'Items'
		.indexmember  'Items'
		.newindexmember  'Items'
	end

	function structs.f.GameClasses(define)
		define
		[0x4FD9FC].array(16).u1  'HPFactor'
		[0x4FDA0C].array(16).u1  'SPFactor'
		[0x4FD9DC].array(16).u1  'HPBase'
		[0x4FD9EC].array(16).u1  'SPBase'
		[0x4FDD18].array(16).array(39).u1  'Skills'
		 .Info "0 - not available,  1 - Basic,  2 - Expert,  3 - Master, 4 - GM"
		[0x4FDA20].array(16).array(7).struct(structs.StartStat)  'StartingStats'
		[internal.SPStatKinds].array(16).u1  'SPStats'  -- 0 - no SP, 1 - Intellect, 2 - Personality, 3 - both
	end

	function structs.f.GameClassKinds(define)
		define
		[0x4FDBE0].array(8).array(39).u1  'StartingSkills'
		 .Info "0 - can't choose, 1 - can choose on start, 2 - given on start"
	end

end

function structs.f.StartStat(define)
	define
	.i1  'Base'
	.i1  'Max'
	.i1  'Spend'
	 .Info "how much you spend on it to add a point"
	.i1  'Add'
	 .Info "how much is added when you spend a point"
end

-- bounties, deaths, prisons, Page Victories, Squire, Knight, Lord, Bounty Creature, Killed bounty creature,  "unknown coords", Artifacts found
function structs.f.GameParty(define)
	define
	[mmv(0x908C98, 0xACD4EC, 0xB21554)].array(3).i4  'Pos'
	[mmv(0x908C98, 0xACD4EC, 0xB21554)].i4  'X'
	.i4  'Y'
	.i4  'Z'
	.i4  'Direction'
	.i4  'LookAngle'
	[mmv(0x908CCC, 0xACD520, 0xB21588)].i4  'SpeedZ'
	[mmv(0x908CE4, 0xACD538, 0xB215A0)].i4  'FallStartZ'
	if mmver < 8 then
		define
		[mmv(0x908F34, 0xACD804)].array(4).struct(structs.Player)  'PlayersArray'
		[mmv(0x944C68, 0xA74F48)].array(4).pstruct(structs.Player)  'Players'
		[mmv(0x90E7A4, 0xAD44F4)].array(1, 2).struct(structs.NPC)  'HiredNPC'
	else
		define
		[0xB20E90 + 2540].array(50).struct(structs.Player)  'PlayersArray'
		[0xB20E90 + 375740].array(5).i4  'PlayersIndexes'
		[0xB20E90 + 375740].array{5, lenA = i4, lenP = 0xB7CA60}.CustomType('Players', 4, function(o, obj, name, val)
			if val then
				local i = (val["?ptr"] - Party.PlayersArray["?ptr"])/structs.Player["?size"]
				Party.PlayersIndexes[name] = Party.PlayersArray[i] and val
			else
				local i = Party.PlayersIndexes[name]
				if i < 0 or i >= 50 then
					i = 0
				end
				return Party.PlayersArray[i]
			end
		end)
	end
	define
	.indexmember  'Players'
	.newindexmember  'Players'
	[mmv(0x90E83C, 0xACCE6C, 0xB20EC4)].i8  'LastRegenerationTime'
	[mmv(0x908E34, 0xACD6C4, 0xB21738)].array(mmv(16, 20, 20)).struct(structs.SpellBuff)  'SpellBuffs'
	[mmv(0x908CE8, 0xACD53C, 0xB215A4)].b4  'Flying'
	[mmv(0x908D50, 0xACD56C, 0xB215D4)].i4  'Gold'
	[mmv(0x908D54, 0xACD570, 0xB215D8)].i4  'BankGold'
	[mmv(0x908D2C, 0xACD560, 0xB215C8)].i4  'Food'
	[mmv(0xACD574, 0xACD574, 0xB215DC)].i4  'Deaths'
	[mmv(0xACD57C, 0xACD57C, 0xB215E4)].i4  'PritsonTerms'
	if mmver > 6 then
		define
		[mmv(nil, 0xAE3060, 0xBB2EF4)].i4  'Fine'
		[mmv(nil, 0xACD580, 0xB215E8)].i4  'MontersHunted'
		[mmv(nil, 0xACD588, 0xB215F0)].array(5).i4  'MonsHuntTarget'  -- only index 0 is used in MM8
		[mmv(nil, 0xACD588, 0xB215FA)].array(5).i4  'MonsHuntKilled'  -- only index 0 is used in MM8
	end
	define
	[mmv(0x908D6D, 0xACD59D, 0xB2160F)].array(512).abit  'QBits'
	[mmv(0x908DAD, 0xACD636, 0xB216A8)].array(1, mmv(128, 255, 300)).abit  'AutonotesBits'
	[mmv(0xACD5ED, 0xACD5ED, 0xB2165F)].i1  'InArenaQuest'
	if mmver > 6 then
		define
		.i1  'ArenaWinsPage'
		.i1  'ArenaWinsSquire'
		.i1  'ArenaWinsKnight'
		.i1  'ArenaWinsLord'
		[mmv(nil, 0xACD5DD, 0xB2164F)].array(16).b1  'ArcomageWins'
	end
	define[mmv(0x908DCB, 0xACD5F2, 0xB21664)].array(mmv(400, 500, 500), mmv(429, 567, 567)).b1  'ArtifactsFound'
	if mmver == 7 then
		define[0xACD6C0].i4  'Alignment'
		 .Info "0 - good, 1 - neutral, 2 - evil"
	end
	if mmver == 6 then
		define[0x908D48].i4  'Reputation'
	else
		define.CustomType('Reputation', 0, function(o, obj, name, val)
			if val == nil then
				return Map.Reputation
			else
				Map.Reputation = val
			end
		end)
		[mmv(nil, 0xACD364, 0xB213CC)].array(1, 29).i8  'History'
	end
	define[offsets.CurrentPlayer].CustomType('CurrentPlayer', 4, function(o, obj, name, val)
		if val == nil then
			return u4[o] - 1
		else
			u4[o] = val + 1
		end
	end)	
	[mmv(0x90E838, 0xAD45B0, 0xB7CA88)].alt.i4  'StateBits'
	.bit ('NeedRender', 2)
	.bit ('Drowning', 4)
	.bit ('InAir', 8)
	.bit ('EnemyDetectorRed', 0x10)
	.bit ('EnemyDetectorYellow', 0x20)
	.bit ('FlyingBit', 0x40)
	.bit ('WaterWalkingBit', 0x80)
	.bit ('InJumpSpell', 0x100)
	.bit ('InLava', 0x200)
	
	local c = define.class
	c.ptr = mmv(0x908C70, 0xACCE38, 0xB20E90)  -- start of Party.bin structure
	function define.f.RestAndHeal(mins)
		if mins then
			mem.call(mmv(0x496180, 0x4B1B3E, 0x4B0341), 0, mins % 0x100000000, mins:div(0x100000000))
			Game.Weather.New()
		else
			mem.call(mmv(0x484D40, 0x490CFA, 0x48FE9C), 1, mmv(0x908C70, 0xACCE38, 0xB20E90))
		end
	end
	define
	.func{name = "Wait", p = mmv(0x487980, 0x4938C9, 0x491C65), cc = 2, must = 1}
	 .Info{Sig = "Minutes"}
	.func{name = "FindActivePlayer", p = mmv(0x487780, 0x493707, 0x491A55), cc = 1; c.ptr}
	.func{name = "GetFame", p = mmv(0x485510, 0x491356, 0x49039B), cc = 1; c.ptr}
	.func{name = "GetRepuatation", p = mmv(0x47D600, 0x47752F, 0x41AB72), cc = 1; c.ptr}
	.func{name = "AddGold", p = mmv(0x41EDE0, 0x420BAE, 0x420131), cc = 2, must = 1; 0, 0}
	 .Info{Sig = "Gold, Kind = 0";  "Kind values:\n"..
	 "0 = increase by Banker, give some part to followers\n"..
	 "1 = take exect amount, ignore followers\n"..
	 "2 = [MM7, MM8] take all and don't show message, just clear status message\n"..
	 "3 = [MM7, MM8] take all and don't change status message"}
	if mmver < 8 then
		define.func{name = "HasNPCProfession", p = mmv(0x467F30, 0x476399, nil), cc = 2, must = 1, ret = true}
	end
end

-- Character_GetInventoryItemIndex

--[[
	const.BonusStat
	-- stditems, spcitems
]]

function structs.f.Player(define)
	if mmver < 8 then
		define[mmv(0x11, 0xB8)].u1  'Sex'
	else
		define[0xC8].string(256)  'Biography'  -- length is unknown
		.method{p = 0x48F5CE, name = "GetSex"; 0}
	end
	define
	[mmv(0x1380, 0x0, 0x0)].array(mmv(17, 20, 20)).i8  'Conditions'
	[mmv(0x1420, 0xA0, 0xA0)].i8  'Experience'
	[mmv(0x1, 0xA8, 0xA8)].string(mmv(16, 16, 32))  'Name'
	[mmv(0x12, 0xB9, 0x352)].u1  'Class'
	[mmv(0x0, 0xBA, 0x353)].u1  'Face'
	[mmv(0x14, 0xBC, 0x354)].array(7).struct(structs.BaseBonus)  'Stats'
	[mmv(0x14, 0xBC, 0x354)].i2  'MightBase'
	.i2  'MightBonus'
	.i2  'IntellectBase'
	.i2  'IntellectBonus'
	.i2  'PersonalityBase'
	.i2  'PersonalityBonus'
	.i2  'EnduranceBase'
	.i2  'EnduranceBonus'
	.i2  'SpeedBase'
	.i2  'SpeedBonus'
	.i2  'AccuracyBase'
	.i2  'AccuracyBonus'
	.i2  'LuckBase'
	.i2  'LuckBonus'
	.i2  'ArmorClassBonus'
	.i2  'LevelBase'
	.i2  'LevelBonus'
	.i2  'AgeBonus'
	[mmv(0x60, 0x108, 0x378)].array(mmv(31, 37, 39)).i2  'Skills'
	[mmv(0x7F, 0x152, 0x3C6)].array(mmv(100, 104, 104)).abit  'Awards'
	[mmv(0xBF, 0x192, 0x406)].array(mmv(100, 100, 138)).b1  'Spells'
	.skip(mmv(5, 0, 0))
	.array(mmv(181, 264, 264), mmv(187, 270, 270)).b4  'UsedBlackPotions'
	[mmv(0x144, 0x214, 0x4A8)].array(1, 138).struct(structs.Item)  'Items'
	[mmv(0x105C, 0x157C, 0x1810)].array(126).i4  'Inventory'  -- positive: item number,  negative: main inventoy slot number
	 .Info "positive: item number,  negative: main inventoy slot number"
	if mmver == 6 then
		define
		[0x1254].union  'Resistances'
			.struct(structs.BaseBonus)(const.Damage.Fire)
			.struct(structs.BaseBonus)(const.Damage.Cold)
			.struct(structs.BaseBonus)(const.Damage.Elec)
			.struct(structs.BaseBonus)(const.Damage.Poison)
			.struct(structs.BaseBonus)(const.Damage.Magic)
		.union()
		[0x1254].i2  'FireResistanceBase'
		[0x1256].i2  'FireResistanceBonus'
		[0x1258].i2  'ColdResistanceBase'
		[0x125A].i2  'ColdResistanceBonus'
		[0x125C].i2  'ElecResistanceBase'
		[0x125E].i2  'ElecResistanceBonus'
		[0x1260].i2  'PoisonResistanceBase'
		[0x1262].i2  'PoisonResistanceBonus'
		[0x1264].i2  'MagicResistanceBase'
		[0x1266].i2  'MagicResistanceBonus'
	else
		define
		[mmv(nil, 0x1774, 0x1A08)].array(11).struct(structs.PlayerResistanceBaseBonus)  'Resistances'
		[mmv(nil, 0x1774, 0x1A08)].i2  'FireResistanceBase'
		.i2  'AirResistanceBase'
		.i2  'WaterResistanceBase'
		.i2  'EarthResistanceBase'
		.i2  ''  -- UnusedResistance1Base
		.i2  ''  -- UnusedResistance2Base
		.i2  'SpiritResistanceBase'
		.i2  'MindResistanceBase'
		.i2  'BodyResistanceBase'
		.i2  ''  -- UnusedResistance3Base
		.i2  ''  -- UnusedResistance4Base
		.i2  'FireResistanceBonus'
		.i2  'AirResistanceBonus'
		.i2  'WaterResistanceBonus'
		.i2  'EarthResistanceBonus'
		.i2  ''  -- UnusedResistance1Bonus
		.i2  ''  -- UnusedResistance2Bonus
		.i2  'SpiritResistanceBonus'
		.i2  'MindResistanceBonus'
		.i2  'BodyResistanceBonus'
		.i2  ''  -- UnusedResistance3Bonus
		.i2  ''  -- UnusedResistance4Bonus
		[mmv(nil, 0x1920, 0x1BE4)].i4  'Voice'
	end
	define
	[mmv(0x1268, 0x17A0, 0x1A34)].array(mmv(16, 24, 27)).struct(structs.SpellBuff)  'SpellBuffs'
	[mmv(0x137C, 0x1934, 0x1BF2)].i2  'RecoveryDelay'
	[mmv(0x1410, 0x1938, 0x1BF4)].i4  'SkillPoints'
	[mmv(0x1414, 0x193C, 0x1BF8)].i4  'HP'
	[mmv(0x1414, 0x193C, 0x1BF8)].i4  'HitPoints'
	[mmv(0x1418, 0x1940, 0x1BFC)].i4  'SP'
	[mmv(0x1418, 0x1940, 0x1BFC)].i4  'SpellPoints'
	[mmv(0x141C, 0x1944, 0x1C00)].i4  'BirthYear'
	[mmv(0x1428, 0x1948, 0x1C04)].array(16).i4  'EquippedItems'
	[mmv(0x1428, 0x1948, 0x1C04)].i4  'ItemExtraHand'
	.i4  'ItemMainHand'
	.i4  'ItemBow'
	.i4  'ItemArmor'
	.i4  'ItemHelm'
	.i4  'ItemBelt'
	.i4  'ItemCloak'
	.i4  'ItemGountlets'
	.i4  'ItemBoots'
	.i4  'ItemAmulet'
	.i4  'ItemRing1'
	.i4  'ItemRing2'
	.i4  'ItemRing3'
	.i4  'ItemRing4'
	.i4  'ItemRing5'
	.i4  'ItemRing6'
	[mmv(0x1468, 0x1988, 0x1C44)].i4  'SpellBookPage'
	[mmv(0x152F, 0x1A4F, 0x1C45)].u1  'QuickSpell'
	[mmv(0x1530, 0x1A50, 0x1C46)].array(512).abit  'PlayerBits'
	if mmver < 8 then
		define
		[mmv(0x1570, 0x1A90)].i1  'MeleeAttackBonus'
		[mmv(0x1572, 0x1A92)].i1  'MeleeDamageBonus'
		[mmv(0x1574, 0x1A94)].i1  'RangedAttackBonus'
		[mmv(0x1576, 0x1A96)].i1  'RangedDamageBonus'
		[mmv(0x1578, 0x1A98)].i1  'FullHPBonus'
		[mmv(0x1578, 0x1A98)].i1  'FullHitPointsBonus'
		[mmv(0x157A, 0x159A)].i1  'FullSPBonus'
		[mmv(0x157A, 0x159A)].i1  'FullSpellPointsBonus'
	end
	define
	[mmv(0x157C, 0x1A9C, 0x1C86)].i2  'Expression'
	[mmv(0x157E, 0x1A9E, 0x1C88)].i2  'ExpressionTimePassed'
	[mmv(0x1580, 0x1AA0, 0x1C8A)].i2  'ExpressionLength'
	[mmv(0x158C, 0x1AAC, 0x1C98)].array(5).struct(structs.LloydBeaconSlot)  'Beacons'
	[mmv(0x1618, 0x1B38, 0x1D24)].u1  'DevineInterventionCasts'
	[mmv(0x1619, 0x1B39, 0x1D25)].u1  'ArmageddonCasts'
	.size = mmv(0x161C, 0x1B3C, 0x1D28)
	if mmver > 6 then
		define[mmv(nil, 0x1B3A, 0x1D26)].u1  'FireSpikeCasts'
	end

	define
	.method{p = mmv(0x47D830, 0x48C83B, 0x48C31F), name = "GetBaseMight"}
	.method{p = mmv(0x47D850, 0x48C852, 0x48C336), name = "GetBaseIntellect"}
	.method{p = mmv(0x47D870, 0x48C869, 0x48C34D), name = "GetBasePersonality"}
	.method{p = mmv(0x47D890, 0x48C880, 0x48C364), name = "GetBaseEndurance"}
	.method{p = mmv(0x47D8B0, 0x48C897, 0x48C37B), name = "GetBaseAccuracy"}
	.method{p = mmv(0x47D8D0, 0x48C8AE, 0x48C392), name = "GetBaseSpeed"}
	.method{p = mmv(0x47D8F0, 0x48C8C5, 0x48C3A9), name = "GetBaseLuck"}
	.method{p = mmv(0x47D910, 0x48C8DC, 0x48C3C0), name = "GetBaseLevel"}
	.method{p = mmv(0x47D930, 0x48C8F3, 0x48C3D7), name = "GetLevel"}
	.method{p = mmv(0x47D960, 0x48C922, 0x48C406), name = "GetMight"}
	.method{p = mmv(0x47DAA0, 0x48C9A8, 0x48C462), name = "GetIntellect"}
	.method{p = mmv(0x47DBE0, 0x48CA25, 0x48C4BF), name = "GetPersonality"}
	.method{p = mmv(0x47DD20, 0x48CAA2, 0x48C51C), name = "GetEndurance"}
	.method{p = mmv(0x47DE60, 0x48CB1F, 0x48C579), name = "GetAccuracy"}
	.method{p = mmv(0x47DFA0, 0x48CB9C, 0x48C5D6), name = "GetSpeed"}
	.method{p = mmv(0x47E0E0, 0x48CC19, 0x48C633), name = "GetLuck"}
	.method{p = mmv(0x47E270, 0x48CCDB, 0x48C690), name = "GetMeleeAttack"; false}
	 .Info{Sig = "IgnoreExtraHand(MM7+) = false"}
	.method{p = mmv(0x47E410, 0x48CDC1, 0x48C759), name = "CalcMeleeDamage";  false, false, -1}
	 .Info{Sig = "JustWeaponDamage = false, IgnoreExtraHand = false, MonsterId = -1"}
	.method{p = mmv(0x47E810, 0x48D09F, 0x48C9FE), name = "GetRangedAttack"}
	.method{p = mmv(0x47EAD0, 0x48D1E4, 0x48CB07), name = "CalcRangedDamage";  -1}
	 .Info{Sig = "MonsterId = -1"}
	.method{p = mmv(0x47EB80, 0x48D2D0, 0x48CBFB), name = "GetMeleeDamageRangeText", ret = ""}
	.method{p = mmv(0x47EEB0, 0x48D37C, 0x48CC98), name = "GetRangedDamageRangeText", ret = ""}
	.method{p = mmv(0x47F010, 0x48D440, 0x48CD4D), name = "CanTrain"}
	.method{p = mmv(0x47FB60, 0x48DB9F, 0x48D026), name = "AddHP", must = 1}
	 .Info{Sig = "Amount"}
	.method{p = mmv(0x47FEE0, 0x48DC04, 0x48D078), name = "DoDamage", must = 1;  0, const.Damage.Phys}
	 .Info{Sig = "Damage, DamageKind:const.Damage = const.Damage.Phys"}
	.method{p = mmv(0x480010, 0x48DCDC, 0x48D166), name = "DoBadThing", must = 1}
	 .Info{Sig = "Thing:const.MonsterBonus"}
	.method{p = mmv(0x481A80, 0x48E19B, 0x48D62A), name = "GetAttackDelay"; false}
	 .Info{Sig = "Shoot = false"}
	.method{p = mmv(0x481EA0, 0x48E4F0, 0x48D9B4), name = "GetFullHP"}
	.method{p = mmv(0x482090, 0x48E55D, 0x48DA18), name = "GetFullSP"}
	define.class.GetFullHitPoints = define.class.GetFullHP
	define.class.GetFullSpellPoints = define.class.GetFullSP
	define.class.AddHitPoints = define.class.AddHP
	if mmver > 6 then
		define
		.method{p = mmv(nil, 0x48CD2B, 0x48C6D5), name = "GetMeleeDamageMin"}
		.method{p = mmv(nil, 0x48CD76, 0x48C717), name = "GetMeleeDamageMax"}
		.method{p = mmv(nil, 0x48D10A, 0x48CA37), name = "GetRangedDamageMin"}
		.method{p = mmv(nil, 0x48D177, 0x48CA9F), name = "GetRangedDamageMax"}
		.method{p = mmv(nil, 0x48D6B6, 0x48CF8A), name = "HasItemBonus"}
		.method{p = mmv(nil, 0x48D6EF, 0x48CFC3), name = "WearsItem"}
		.method{p = mmv(nil, 0x48E737, 0x48DBA2), name = "GetBaseResistance", must = 1}
		.method{p = mmv(nil, 0x48E7C8, 0x48DD6B), name = "GetResistance", must = 1}
	else
		define
		.method{p = 0x4829A0, name = "GetBaseFireResistance"}
		.method{p = 0x4829C0, name = "GetBaseElectricityResistance"}
		.method{p = 0x4829E0, name = "GetBaseColdResistance"}
		.method{p = 0x482A00, name = "GetBasePoisonResistance"}
		.method{p = 0x482A20, name = "GetBaseMagicResistance"}
		.method{p = 0x482A40, name = "GetFireResistance"}
		.method{p = 0x482A90, name = "GetElectricityResistance"}
		.method{p = 0x482AE0, name = "GetColdResistance"}
		.method{p = 0x482B30, name = "GetPoisonResistance"}
		.method{p = 0x482B80, name = "GetMagicResistance"}
	end
	define
	.method{p = mmv(0x482570, 0x48E64E, 0x48DAB9), name = "GetBaseArmorClass"}
	.method{p = mmv(0x482700, 0x48E687, 0x48DAF2), name = "GetArmorClass"}
	.method{p = mmv(0x4828A0, 0x48E6D4, 0x48DB3F), name = "GetBaseAge"}
	.method{p = mmv(0x482920, 0x48E724, 0x48DB8F), name = "GetAge"}
	.method{p = mmv(0x482BB0, 0x48E8ED, 0x48DF81), name = "Recover"}
	.method{p = mmv(0x482C80, 0x48E962, 0x48DFF8), name = "SetRecoveryDelay", must = 1}
	 .Info{Sig = "Delay"}
	.method{p = mmv(0x482D30, 0x48E9EC, 0x48E127), name = "GetMainCondition"}
	-- 482E6E (MM6) Character_CalcSpecialBonusByItems
	.method{p = mmv(0x482E80, 0x48EAA6, 0x48E213), name = "CalcStatBonusByItems", must = 1;  0, false}
	 .Info{Sig = "Stat:const.Stats, IgnoreExtraHand(MM7+) = false"}
	.method{p = mmv(0x483800, 0x48F734, 0x48EE09), name = "CalcStatBonusByMagic", must = 1}
	 .Info{Sig = "Stat:const.Stats"}
	.method{p = mmv(0x483930, 0x48FBF8, 0x48F084), name = "CalcStatBonusBySkills", must = 1}
	 .Info{Sig = "Stat:const.Stats"}
	.method{p = mmv(0x485340, 0x4911EB, 0x49028F), name = "GetMerchantTotalSkill"}
	.method{p = mmv(0x4853E0, 0x4912A8, 0x49031C), name = "GetDisarmTrapTotalSkill"}
	.method{p = mmv(0x488F50, 0x494A1D, 0x492D6A), name = "ShowFaceExpression", must = 1;  0, 0}
	 .Info{Sig = "Expression, Time = 0"}
	if mmver == 6 then
		define.method{p = 0x4852D0, name = "GetDiplomacyTotalSkill"}
	-- 486CF0 Character_CanTakeItemInPos
	-- 486DD0 Character_ItemsCount
	-- 486DF0 Character_PutItemInPos
	else
		define
		.method{p = mmv(nil, 0x48F87A, 0x48EF4F), name = "GetSkill", must = 1}
		.method{p = mmv(nil, 0x4948A9, 0x492BCD), name = "ShowFaceAnimation", must = 1;  0, 0}
		 .Info{Sig = "Animation"}
		.method{p = mmv(nil, 0x491252, 0x4902DF), name = "GetPerceptionTotalSkill"}
		.method{p = mmv(nil, 0x49130F, 0x49036E), name = "GetLearningTotalSkill"}
	end
	if mmver == 7 then
		define.method{p = 0x490101, name = "GetRace"}
	end
	
	function define.f:EnumActiveItems()
		local i = -1
		return function()
			while i < 15 do
				i = i + 1
				local slot = self.EquippedItems[i]
				local item = (slot ~= 0 and self.Items[slot])
				if item and item.Condition:And(2) == 0 then
					return item, i
				end
			end
		end
	end
end

--[[
Game files meaning:
DIFT - Interface Frame Table
DPFT - Player Frame Table
DSFT - Sprite Frame Table
DTFT - Texture Frame Table
DTILE - Tiles List
DMONLIST - Monsters List
DDECLIST - Decorations (MapSprite) List
DOBJLIST - Objects (MapObject) list
DSOUNDS - Sounds List
DOVERLAY - Overlays List (things like green stars shown over players portraits, spell icons, water walk indicator etc.)
]]
